with Irudiak;
with Ada.Integer_Text_IO;
package body Irudi_Listak is
   procedure Sortu_Irudi_Lista (
                                L : in out Irudi_Lista ) is
   begin
      L.Zenbat:=0;
   end Sortu_Irudi_Lista;

   procedure Gehitu_Irudia_Igarren_Posizioan (
                                              Irudia : in     Irudiak.Irudi;
                                              N      : in     Integer;
                                              L      : in out Irudi_Lista    ) is
   begin
      for I in reverse N..L.Zenbat loop
         L.Irudiak(I+1):=L.Irudiak(I);
      end loop;
      L.Zenbat:=L.Zenbat+1;
      L.Irudiak(N):=Irudia;
   end Gehitu_Irudia_Igarren_Posizioan;


   procedure Transformazio_Aukerak (Irudia : in     Irudiak.Irudi;
                                    Transf : in     String;
                                    A      : in     Float;
                                    L      :    out Irudi_Lista) is
      Berria : irudiak.Irudi;
   begin
      L.Zenbat := 1;
      L.Irudiak(1):= Irudia;
      for I in 1..19 loop
         --Lortu irudia
         Berria := Irudia;
         Irudiak.Transformazioa(Irudia, Berria, Transf, Float(I)*A);
         -- Gorde listan
         L.Zenbat := L.Zenbat + 1;
         L.Irudiak(L.Zenbat):= Berria;
      end loop;
   end Transformazio_Aukerak ;


   procedure Sortu_Katalogo (
                             Katalogo :    out Irudiak.irudi;
                             L :       in      Irudi_Lista  ) is
      Irudia, Im_Txiki: Irudiak.irudi;
      X, Y: Integer;
      Iruditxo_Zabalera: constant Integer := (Irudiak.Max_Zabalera-12) / 5;
      Iruditxo_Altuera : constant Integer := Iruditxo_Zabalera ;
   begin
      Irudiak.Irudia_Zuritan_Sortu(Katalogo);
      for I in 1..L.Zenbat loop
         Irudia:= L.Irudiak(I);
         Irudiak.Berdimentsionatu(Irudia,Iruditxo_Zabalera, Iruditxo_Altuera, Im_Txiki);
         if I mod 5 =0
         then
            X:= ((I / 5)-1)* (Iruditxo_Zabalera + 2);
            Y:= 4*(Iruditxo_Altuera +2);
         else
            X:= (I / 5)* (Iruditxo_Zabalera + 2);
            Y:= ((I mod 5)-1) * (Iruditxo_Altuera +2);
         end if;

         Irudiak.Txertatu_Koadroa (Katalogo, Im_Txiki, X, Y );
      end loop;
   end Sortu_Katalogo;

end Irudi_Listak;
